<?php
namespace TecFood\Strategies;

class Context
{
    private $strategy;

    public function __construct($strategy)
    {
        $this->strategy = $strategy;
    }

    public function setStrategy($strategy)
    {
        $this->strategy = $strategy;
    }

    public function validate(&$spreadsheetData)
    {
        $this->strategy->validate($spreadsheetData);
    }
    
    public function formatToSave(&$spreadsheetData)
    {
        $this->strategy->formatToSave($spreadsheetData);
    }
    
    public function formatToView(&$spreadsheetData)
    {
        $this->strategy->formatToView($spreadsheetData);
    }
    
    public function save($spreadsheetData)
    {
        $this->strategy->validate($spreadsheetData);
        
        $this->strategy->save($spreadsheetData);
    }
}
